program Project2;
{$APPTYPE CONSOLE}
uses
  sysutils,
  Classes,
  TypInfo,
  Forms,
  PaxCompiler,
  PaxProgram,
  PaxRegister,
  IMPORT_Common;

type
  TMyHandler = class
  public
    procedure UnknownDirectiveHandler(Sender: TPaxCompiler;
      const Directive: string; var ok: Boolean);
  end;

procedure TMyHandler.UnknownDirectiveHandler(Sender: TPaxCompiler;
  const Directive: string; var ok: Boolean);
begin
  ok := true;
end;

var
  MyHandler: TMyHandler;
  PaxCompiler1: TPaxCompiler;
  PaxProgram1: TPaxProgram;
  PaxPascalLanguage1: TPaxPascalLanguage;
begin
  // Build all units, save pcu-files and create compiled script

  MyHandler := TMyHandler.Create;
  PaxCompiler1 := TPaxCompiler.Create(nil);
  PaxCompiler1.OnUnknownDirective := MyHandler.UnknownDirectiveHandler;

  PaxProgram1 := TPaxProgram.Create(nil);
  PaxPascalLanguage1 := TPaxPascalLanguage.Create(nil);

  try
    PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
    PaxCompiler1.AddModule('unit2', 'Pascal');
    PaxCompiler1.AddCodeFromFile('unit2', 'unit2.pas');

    if PaxCompiler1.Compile(PaxProgram1, true, false) then
    begin
    // build with run-time packages
      PaxProgram1.SaveToFile('unit2.pcu');
      writeln('ok');
    end
    else
    begin
      writeln(PaxCompiler1.ErrorMessage[0]);
      writeln(PaxCompiler1.ErrorLine[0]);
    end;
  finally
    PaxCompiler1.Free;
    PaxProgram1.Free;
    PaxPascalLanguage1.Free;
    MyHandler.Free;
  end;

  writeln('Press any key...');
  Readln;
end.

